module solver_obj_mod
! Solver abstract object
! Last edited by Ali Almomin 08/24/2015

  use stepper_obj_mod
  use prob_obj_mod
  use terminate_obj_mod

  implicit none

  private
  public :: solver_obj

  type, abstract                   :: solver_obj
    contains
    procedure(run_solver),deferred :: run
  end type

  abstract interface
    integer function run_solver(this, modl, prob, stpr, term)
      import                       :: solver_obj
      import                       :: stepper_obj
      import                       :: terminate_obj
      import                       :: prob_obj
      class(solver_obj)            :: this
      !-------------------- interface variables -------
      real, dimension(:)           :: modl            ! model (input/output)
      class(prob_obj)                :: prob
      class(stepper_obj)           :: stpr
      class(terminate_obj)             :: term
    end function
  end interface

end module
